# -*- coding: utf-8 -*-
import sys, re, json
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urlparse import urlparse, parse_qs, urljoin
except ImportError:
    from urllib.parse import urlparse, parse_qs, urljoin
if sys.version_info[0] == 3:
    from functools import reduce


def getsoup(content):
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(content, 'html.parser')
    return BeautifulSoup(content, 'html5lib')


def getjson(url):
    return json.load(urlopen(url))


def gethttp(url):
    return urlopen(url, timeout=3).read().decode('utf-8')


def play(url):
    import pprint
    # def reduce(function, sequence, initial=None):
    #     return type(self), (self.func,), (self.func, self.args,
    #                                       self.keywords or None, self.__dict__ or None)
    #     pass

    def concat(a, b):
        return a + b

    def remove_quotes(s):
        if s is None or len(s) < 2:
            return s
        for quote in ('"', "'",):
            if s[0] == quote and s[-1] == quote:
                return s[1:-1]
        return s

    def parse_js_value(inp):
        inp = re.sub(r'/\*(?:(?!\*/).)*?\*/', '', inp)
        if '+' in inp:
            inps = inp.split('+')
            return reduce(
                concat, map(parse_js_value, inps))
        inp = inp.strip()
        if inp in js_vars:
            return js_vars[inp]
        return remove_quotes(inp)

    # def get_var(vname):
    #     #open('test2.txt', 'wb').write(content.encode('utf-8'))
    #     assignment = re.search(r'var\s+(?:%s)\s*=\s*(.*?)\s*;' % vname, content)
    #     if not assignment:
    #         print('Error: ' + vname)
    #         open('test3.txt', 'wb').write(content.encode('utf-8'))
    #         return None
    #     assignment = assignment.group(1)
    #     assignment = re.sub(r'/\*(?:(?!\*/).)*?\*/', '', assignment)
    #     print(assignment)
    #     ret = ''
    #     for assn in assignment.split('+'):
    #         ret += get_var(assn)
    #     return ret
    #     #if '+' in assignment:
    #     #    assignments = assignment.split('+')
    #     #    return reduce(concat, map(get_var, assignments))
    #     #print(assignment)
    #     #return assignment

    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': 'pornhub 100', 'error': str(e)}
    flashvars = re.search(r'var\s+flashvars_\d+\s*=\s*({.+?});', content)
    if not flashvars:
        return {'code': 'pornhub 101'}
    flashvars = flashvars.group(1)
    qualities = []
    try:
        flashvars = json.loads(flashvars)
        for e in flashvars['mediaDefinitions']:
            qualities.append(e['quality'])
        title = flashvars['video_title']
    except Exception as e:
        return {'code': 'pornhub 102', 'error': str(e)}
    assignments = re.search(r'(var\s+quality_.+)', content)
    if not assignments:
        return {'code': 'pornhub 103'}
    offset1 = assignments.start()
    offset2 = content[:offset1].rfind('\n')
    offset3 = content[offset1:].find('\n') + offset1
    assignments = content[offset2:offset3]
    assignments = assignments.split(';')
    js_vars = {}
    for assn in assignments:
        assn = assn.strip()
        if not assn:
            continue
        assn = re.sub(r'var\s+', '', assn)
        vname, value = assn.split('=', 1)
        js_vars[vname] = parse_js_value(value)
    urls = {}
    for quality in qualities:
        if 'quality_%sp' % quality in js_vars:
            urls[quality + 'p'] = js_vars['quality_%sp' % quality]
    if not urls:
        return {'code': 'pornhub 104'}
    return {'title': title, 'url': urls}

def list(url):
    try:
        soup = getsoup(gethttp(url))
    except Exception as e:
        return {'code': 'pornhub 200', 'error': str(e)}
    ret = []
    for e in soup.find_all('li', {'class': 'videoBox'}):
        title = e.a['title'].strip()
        e1 = e.find('div', {'class': 'rating-container'})
        if e1:
            e2 = e1.find('div', {'class': 'value'})
            if e2:
                title = e2.text + ' ' + title
        ret.append({'title': title, 'url': urljoin(url, e.a['href'])})
    e = soup.find('li', {'class': 'page_next'})
    if e:
        ret.append({'title': 'Load more', 'url': urljoin(url, e.a['href'])})
    return ret
